= How do I add Checkstyle analysis to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://checkstyle.sourceforge.net/ Checkstyle] runs against Java source files, and focuses on stylistic coding 
practices. It is often used to fail a build in order to enforce a team's coding standards.

== For Maven projects ==

To use Checkstyle in a Maven project with the default ruleset, simply use `mvn checkstyle:checkstyle`. 

If you add the following lines to your `pom.xml` file, you can configure the rules to use.
Checkstyle will also report its findings as part of the Maven site report (`mvn site`).

{{{
#!text/xml
<project>
  ...
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-checkstyle-plugin</artifactId>
        <configuration>
          <configLocation>${basedir}/checkstyle.xml</configLocation>
        </configuration>
      </plugin>
    </plugins>
  </reporting>
  ...
</project>
}}}

The `checkstyle.xml` file location can be specified as a filesystem path, a URL, 
or a classpath resource. In this case, it is specified to be in the `basedir`, 
or top-level, of the project.

== For Ant builds ==

To use Checkstyle in an Ant project, add the following files to a directory in your source tree (`tools/checkstyle-<%= node['tools']['checkstyle']['version'] %>`):
 * `checkstyle-all-<%= node['tools']['checkstyle']['version'] %>.jar`
 * `checkstyle.xml`
 * `checkstyle.xsl`

If you prefer to keep the Checkstyle libraries outside your source tree, change the locations for the `tools.dir` and/or
the `checkstyle.lib.dir` properties in the lines below. You can use a centralized `checkstyle.xml` file (e.g., if
you want all projects to use the same rules, or check in a project-specific configuration file to your source tree.

Add the following lines to your `build.xml` file. `build.dir`, `compile.classpath`, `junit.lib.dir`, `src.dir`, 
and `test.src.dir` should be set appropriately. 

{{{
#!text/xml
	<property name="tools.dir" location="tools"/>
	<property name="checkstyle.lib.dir" location="${tools.dir}/checkstyle-<%= node['tools']['checkstyle']['version'] %>"/>
	<property name="checkstyle.conf.file" location="${checkstyle.lib.dir}/checkstyle.xml"/>	
	<property name="checkstyle.xsl.file" location="${checkstyle.lib.dir}/checkstyle.xsl"/>	

	<property name="report.dir" location="${build.dir}/reports"/>
	<property name="checkstyle.report.dir" location="${report.dir}/checkstyle"/>

	<path id="test.classpath">
		<path refid="compile.classpath"/>
		<fileset dir="${junit.lib.dir}" includes="**/*.jar"/>
	</path>
	<path id="checkstyle.classpath">
		<path refid="test.classpath"/>
		<fileset dir="${checkstyle.lib.dir}" includes="**/*.jar"/>
	</path>

	<taskdef resource="checkstyletask.properties" classpathref="checkstyle.classpath"/>

	<target name="checkstyle" description="Generates a report of code convention violations">
		<property name="checkstyle.result.xml" location="${checkstyle.report.dir}/checkstyle-result.xml"/>
		<mkdir dir="${checkstyle.report.dir}"/>
		<checkstyle config="${checkstyle.conf.file}"
		            failureProperty="checkstyle.failure"
		            failOnViolation="false">
		  <classpath refid="checkstyle.classpath"/>
		  <formatter type="xml" tofile="${checkstyle.result.xml}"/>
		  <fileset dir="${src.dir}" includes="**/*.java"/>
		  <fileset dir="${test.src.dir}" includes="**/*.java"/>
		</checkstyle>

		<property name="checkstyle.report.html" location="${checkstyle.report.dir}/index.html"/>
	    <xslt in="${checkstyle.result.xml}" out="${checkstyle.report.html}" style="${checkstyle.xsl.file}"/>
		<echo message="Checkstyle report is at ${checkstyle.report.html}"/>
	</target>
}}}

== Customizing rules ==

To customize which rules are run, edit the `checkstyle.xml` file. Rules can be enabled and disabled, and some rules can be 
configured to apply in some situations but not others. 

=== More information ===

 * [http://maven.apache.org/plugins/maven-checkstyle-plugin/ Maven options]
 * [http://checkstyle.sourceforge.net/anttask.html Ant options]
 
<%= node['trac']['wiki']['footer'] %>